//+------------------------------------------------------------------+
//|                                               Bar_Distribute.mq4 |
//|                                                      TO StatBars |
//|                                            http://tradexperts.ru |
//+------------------------------------------------------------------+
#property copyright "TO StatBars"
#property link      "http://tradexperts.ru"
#include <lib_Zemckikh.mqh>
#property indicator_chart_window

extern double DP = 10;
extern int TF = 1;
extern double Normalization = 3;
extern color Rect_Color = LightSalmon;
extern bool Prn=false;//True -      Bar_Distribute.csv

double arr[],
       maxArr,
       k_norm, 
       MIN,
       MAX, 
       num_interval;
string Name_L="L_PRDIST", 
       Name_D="R_PRDIST_",
       Name_Lab="Note";
datetime time_set=0;
bool Exit=false;
int handle;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
//   Comment("Bar_Distribute(DP="+DoubleToStr(DP,0)+", TF="+TF+", Normalization="+DoubleToStr(Normalization, 1)+")");
//-------      -----  
     string txt="Bar_Distribute(DP="+DoubleToStr(DP,0)+", TF=" +TF+", Normalization="+DoubleToStr(Normalization, 1)+")"; 
              
     ObjectCreate(Name_Lab, OBJ_LABEL, 0, Time[0], 0);
     ObjectSet(Name_Lab, OBJPROP_CORNER, 0);
     ObjectSet(Name_Lab, OBJPROP_XDISTANCE, 5);
     ObjectSet(Name_Lab, OBJPROP_YDISTANCE, 20);
     ObjectSetText(Name_Lab, txt, 8, "Times New Roman", Blue);
//----------------------------------------------------------------  
   if(!isPeriod(TF))//   - 
    {
     Alert(Symbol()+"("+ Period()+")  - TF="+TF+"!!");
     Exit=true;
     return(0);
    }
   if( ObjectFind( Name_L) < 0 )
   {
      if(time_set==0) time_set=Time[0];
      ObjectCreate( Name_L, OBJ_VLINE, 0, time_set, 0);
      ObjectSet(Name_L, OBJPROP_COLOR, Black);
      //time_set = ObjectGet( Name_L, OBJPROP_TIME1);
   }
   if(Prn) handle=FileOpen("Bar_Distribute.csv", FILE_CSV|FILE_READ|FILE_WRITE  , ';'); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(!ObjectFind(Name_Lab) < 0) ObjectDelete(Name_Lab); 
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      if( StringFind( ObjectName(i), Name_D) >= 0)
         ObjectDelete( ObjectName(i));
      if( ObjectFind( Name_L) >= 0 ) ObjectDelete(Name_L);        
   }
   if(Prn) FileClose(handle);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//<----- -------------------------------->   
   int    i,
          Bar1,
          Bar0,
          nBar,
          visible_Bars,
          curBar;
   double Delta,
          Betta,
          myArr[];
   bool newBar=false;
   datetime time_cur,//  
            prevTime;//  
//<---------------------------------------------------------->   
   k_norm=DP*Point;
   time_cur=ObjectGet( Name_L, OBJPROP_TIME1);//  .
   newBar=isNewBar();
   if(time_cur != time_set)// .    
    {
     newBar=true;//  
     time_set=time_cur;
    } 
   if(!newBar || Exit)return(0);
   for(i = ObjectsTotal() - 1; i >= 0; i--)
   {
      if(StringFind( ObjectName(i), Name_D) >= 0)
         ObjectDelete( ObjectName(i));
   }
  if(time_set == Time[0]) 
   prevTime=TimeCurrent();
  else
   {
    curBar=iBarShift(Symbol(), Period(), time_set);
    prevTime=iTime(Symbol(), Period(), curBar-1);
   } 
   Bar0=iBarShift(Symbol(), TF, prevTime, false);//     TF
   Bar1=iBarShift(Symbol(), TF, time_cur, false);//     TF
   MAX=iHigh(Symbol(), Period(), curBar);
   MIN=iLow(Symbol(), Period(), curBar);
   num_interval = MathCeil( ((MAX-MIN)/Point)/DP);
   ArrayResize(arr, num_interval+1);
   ArrayInitialize(arr, 0.0);
   Distribute(-1, DP, MAX, MIN, Bar0, Bar1, TF, arr);
   i=ArrayMaximum(arr);
   maxArr=arr[i];
   ArrayResize(myArr, num_interval+1);
   ArrayCopy(myArr, arr);
   if(Prn)
    {
     FileWrite( handle, Period(), Symbol( ), TimeToStr(time_set) ); 
     FileWrite( handle, "MAX", "MIN");
     FileWrite( handle, DoubleToStr(MAX, 5), DoubleToStr(MIN,5));
     FileWrite( handle, " /", "", "");
    }
//------------- . ---------------
     nBar=iBarShift(Symbol( ), Period(), time_cur, false);//   
     visible_Bars=WindowFirstVisibleBar();//      
     nBar=visible_Bars-nBar;//    
     Betta=nBar/(Normalization*maxArr);//. 
//---------------------------------------------------------    
   for( i=0; i <= num_interval; i++)
    {
     myArr[i]=Betta*arr[i];//  
     if(Prn)// 
      { 
       Delta=MIN + k_norm*i;
       if(Delta > MAX) Delta=MAX;
       FileWrite( handle, i, DoubleToStr(Delta, 5), DoubleToStr(myArr[i], 5));
      }
    }
   Histogram(k_norm, num_interval, Name_D, Rect_Color, time_set, MIN, myArr);
   return(0);
  }
//+------------------------------------------------------------------+

